C*****************************************
       program GBCD correlations
C*****************************************
       implicit none

       include 'common.fi'

       parameter (CD=11)
       parameter (CD2=11)
       dimension gbd_f(CD,CD,CD,CD2,4*CD2)
       dimension gbd_o(CD,CD,CD,CD2,4*CD2)
       dimension e1(3), e2(3)
       dimension gg1(3,3), gg2(3,3), dg(3,3)
       dimension so1(3,3), so2(3,3), sa(2), so2t(3,3)
       dimension ax(3), avemrd(CD,CD,CD,CD2,4*CD2)
	   dimension aveenergy(CD,CD,CD,CD2,4*CD2)
	   real      delta1, delta2, max
	   integer   iii, point1, point2
	   integer hash, header1, header2
	   character*80 inline	
	   character*8 version	   

       write(6,*) '=============================================='
       write(6,*) ' PROGRAM TO CORRELATE GRAIN BOUNDARY OR ENERGY'
       write(6,*) ' DISTRIBUTION DATA, WITH SYMMETRY CONSIDERATIONS'
       write(6,*)
       write(6,*) '  version 08/02/12'
       write(6,*) '  rohrer@cmu.edu'	   
       write(6,*) '=============================================='
	   
	   version='08/02/12'
       degrad = 180./3.14159
       pi = 4.0*atan(1.0)
       eps = 1.e-6   !  used for testing angles
       HCD = 90.0

       open(21, file='input.txt', status='old')
	   read(21,*)
	   read(21,*) keyword1, keyword2
	   read(21,*) tempword, tempword, tempword
       read(21,*) msym, rotation, radian
	   read(21,*) delta1, delta2
	   close(21)
       point1 = index(keyword1,'.') - 1       
	   point2 = index(keyword2,'.') - 1
	   
	   do i = 1,2000
	    hist(i,1) = 0.0
		hist(i,2) = 0.0
		hist(i,3) = 0.0
		hist(i,4) = 0.0
		hist(i,5) = 0.0
		hist(i,6) = 0.0
		hist2(i,1) = 0.0
		hist2(i,2) = 0.0
		hist2(i,3) = 0.0
		hist2(i,4) = 0.0
		hist2(i,5) = 0.0
		hist2(i,6) = 0.0
	   enddo	

 10     format(a,a)
 12     format(a,a,a,a,a)
 14     format(a)
        write(6,10)'written by correl_test, version ',version
	    write(6,14)'I am comparing file 1:'
	    write(6,14) keyword1
        write(6,14)' to file 2:'
        write(6,14) keyword2

	    open (33, file=keyword1, status='old')
		open (34, file=keyword2, status='old')
		open (36, file=keyword1(1:point1)//'_v_'//keyword2(1:point2)//'.txt'
     &         , status='unknown')
		open (37, file=keyword2(1:point2)//'_v_'//keyword1(1:point1)//'.txt'
     &         , status='unknown')		
        write(36,10)'written by correl_test, version ',version
        write(37,10)'written by correl_test, version ',version				
	    write(36,10)'file 1 = ',keyword1	
	    write(36,10)'file 2 = ',keyword2				
	    write(37,10)'file 1 = ',keyword1	
	    write(37,10)'file 2 = ',keyword2	

		nnline = 0
 100    continue
		read(33,*,end=101)
		nnline=nnline+1
		goto 100
 101    continue
        close(33)
 102    format(A,I6,A)
		write(36,102) 'There are ', nnline, ' lines in the first file'
		write(37,102) 'There are ', nnline, ' lines in the first file'
		
		nnline = 0
 200    continue
		read(34,*,end=201)
		nnline=nnline+1
		goto 200
 201    continue
        close(34)
		write(36,102) 'There are ', nnline, ' lines in the second file'
		write(37,102) 'There are ', nnline, ' lines in the second file'
	    write (36,*) '   '
		write (37,*) '   '
		 write (36,14) 'file 1,  file 2, number of observations'
		 write (37,14) 'file 2,  file 1, number of observations'		 



c Check each line for the string '#'. If found, we know this line is part  
c of the header.  If not, we have reached the data section.		
       open (33, file=keyword1, status='old')
       header1 = 0
       hash = 0
	   do i=1,100  ! max header length is 100 lines
	    read(33, "(a)") inline
	    hash = index(inline, '#')
	    if (hash.ne.0) then
	     header1=header1+1
		 hash=0
	    else
		 goto 108     
	    endif			
	   enddo
 108  close(33)		


       open (34, file=keyword2, status='old')
       header2 = 0
       hash = 0
	   do i=1,100  ! max header length is 100 lines
	    read(34, "(a)") inline
	    hash = index(inline, '#')
	    if (hash.ne.0) then
	     header2=header2+1
		 hash=0
	    else
		 goto 109     
	    endif			
	   enddo
 109  close(34)		




       open (33, file=keyword1, status='old')	  
		do i=1,header1
		 read(33, "(a)") inline
		enddo			 

		open (33, file=keyword1, status='old')
		do i=1,CD
	     do j=1,CD
	      do k=1,CD
	       do ii=1,CD2
	        do jj=1,4*CD2
	         read (33,*) gbd_f(i,j,k,ii,jj)
	        enddo
	       enddo
	      enddo
	     enddo
	   enddo
       close(33)

       open (34, file=keyword2, status='old')	  
		do i=1,header2
		 read(34, "(a)") inline
		enddo	
		
		open (34, file=keyword2, status='old')
		do i=1,CD
	     do j=1,CD
	      do k=1,CD
	       do ii=1,CD2
	        do jj=1,4*CD2
	         read (34,*) gbd_o(i,j,k,ii,jj)
	        enddo
	       enddo
	      enddo
	     enddo
	   enddo
       close(34)
	   
		do i=1,CD
	     do j=1,CD
	      do k=1,CD
	       do ii=1,CD2
	        do jj=1,4*CD2
	         avemrd(i,j,k,ii,jj)=0
			 aveenergy(i,j,k,ii,jj)=0
	        enddo
	       enddo
	      enddo
	     enddo
	   enddo
	   

	   
c     The statement calls the subroutine that contains the symmetry operators.  The variable
c     msym, read from the input file, specifies the symmetry (1 = tetragonal, 2 = hexagonal, 
c     3 = subic, 4 = trigonal), O is a matrix containing the operators, and nsymm is the 
c     number of symmetry operators.  The routine returns O and nsymm.

	  call get_symop (msym, O, nsymm)

	  w1=(pi/2.0)/float(CD)  ! These are the widths of the bins
	  w2=1.0/float(CD)
	  w3=w1
	  w4=w2
	  w5=w1

      max=0.0	  

	  do i=1,CD
	   do j=1,CD
		do k=1,CD
		 do ii=1,CD2
		  do jj=1,4*CD2
		  
		  summrd1=0.0	
		  summrd2=0.0	   
          ct1=0
          ct2=0		  
		  summrd1=summrd1+gbd_f(i,j,k,ii,jj)
		  ct1=ct1+1
		  summrd2=summrd2+gbd_o(i,j,k,ii,jj)
		  ct2=ct2+1

c         In the next part, I have to find all of the equivalent points		  
c         first, I have to get the angular parameter that correspond to this index
c         so that I can apply symmetry operators  
	
		  e1(1)=(i*w1)		  
		  e1(2)=acos(j*w2)	  
		  e1(3)=(k*w3)	  
		  theta=acos(ii*w4)
		  phi=jj*w5
		  call EToG(e1,g)  
		  call AnglesToV (theta, phi, n1)
		  call trans (g, gt)
		  call MToV (gt, n1, n2)
		  
          do i_s=1,nsymm    ! These nested loops find the values in all equivalent cells.	
			do j_s=1,nsymm
		     call symop(O,i_s,so1)
			 call MToV (so1,n1,nf)			 
		     call symop(O,j_s,so2)
			 call trans (so2,so2t)	 
			 call MToM (g, so2t, gg1)
			 call MToM (so1, gg1, dg)
			 call GToE (dg, mort)						 
			 call VToAngles (nf, sa)
			 if (mort(1).lt.(pi*0.5+eps) .and. 
     &         mort(2).lt.(pi*0.5+eps) .and. 
     &         mort(3).lt.(pi*0.5+eps) ) then
			  c1=int(float(CD)*2.0*mort(1)/pi)+1
              c2=int(float(CD)*cos(mort(2)))+1
              c3=int(float(CD)*2.0*mort(3)/pi)+1
              c4=int(float(CD2)*cos(sa(1)))+1
              c5=int(float(4*CD2)*sa(2)/(pi*2.0))+1
			  if (c1.eq.CD+1) c1=CD
              if (c2.eq.CD+1) c2=CD
              if (c3.eq.CD+1) c3=CD
              if (c4.eq.CD2+1) c4=CD2
              if (c4.eq.0) c4=1
			  if (c5.eq.4*CD2+1) c5=4*CD2
			  summrd1=summrd1+gbd_f(c1,c2,c3,c4,c5)
		      ct1=ct1+1
		      summrd2=summrd2+gbd_o(c1,c2,c3,c4,c5)
		      ct2=ct2+1
			 endif
			 
			 !repeat for the interchanged crystals
			 call MToV (so1, n2, nf)
			 call trans (g, gt)
			 call MToM (gt, so2, gg2)
			 call MToM (so1, gg2, dg)
			 call GToE (dg, mort)
			 call VToAngles (nf, sa)
			 if (mort(1).lt.(pi*0.5+eps) .and. 
     &         mort(2).lt.(pi*0.5+eps) .and. 
     &         mort(3).lt.(pi*0.5+eps) ) then
			  c1=int(float(CD)*2.0*mort(1)/pi)+1
              c2=int(float(CD)*cos(mort(2)))+1
              c3=int(float(CD)*2.0*mort(3)/pi)+1
              c4=int(float(CD2)*cos(sa(1)))+1
              c5=int(float(4*CD2)*sa(2)/(pi*2.0))+1
			  if (c1.eq.CD+1) c1=CD
              if (c2.eq.CD+1) c2=CD
              if (c3.eq.CD+1) c3=CD
              if (c4.eq.CD2+1) c4=CD2
              if (c4.eq.0) c4=1
			  if (c5.eq.4*CD2+1) c5=4*CD2
		      summrd1=summrd1+gbd_f(c1,c2,c3,c4,c5)
		      ct1=ct1+1
		      summrd2=summrd2+gbd_o(c1,c2,c3,c4,c5)
		      ct2=ct2+1
			 endif
			 
           enddo
		  enddo


          avemrd1=summrd1/float(ct1)
          avemrd2=summrd2/float(ct1)
	  
		  avemrd(i,j,k,ii,jj)=avemrd1
		  aveenergy(i,j,k,ii,jj)=avemrd2
		  

		  index1=int(avemrd1/delta1)+1

		  hist(index1,1)=hist(index1,1)+avemrd1
		  hist(index1,2)=hist(index1,2)+avemrd2
		  hist(index1,3)=hist(index1,3)+1.0
	  
		  index2=int(avemrd2/delta2)+1
		  hist(index2,4)=hist(index2,4)+avemrd1
		  hist(index2,5)=hist(index2,5)+avemrd2
		  hist(index2,6)=hist(index2,6)+1.0
		
  

		  enddo
		 enddo
		enddo
	   enddo
	   write(6,602)'progress = ',i,'/9th'
	  enddo
	  
 
	  do i=1,CD
	   do j=1,CD
		do k=1,CD
		 do ii=1,CD2
		  do jj=1,4*CD2
 
		  index1=int(avemrd(i,j,k,ii,jj)/delta1)+1
		  hist2(index1,1)=hist2(index1,1)+(((hist(index1,1)/hist(index1,3))-avemrd(i,j,k,ii,jj))**2)
		  hist2(index1,2)=hist2(index1,2)+(((hist(index1,2)/hist(index1,3))-avemrd(i,j,k,ii,jj))**2)
		  hist2(index1,3)=hist2(index1,3)+1.0
		  
		  index2=int(aveenergy(i,j,k,ii,jj)/delta2)+1
		  hist2(index2,4)=hist2(index2,4)+(((hist(index2,4)/hist(index2,6))-aveenergy(i,j,k,ii,jj))**2)
		  hist2(index2,5)=hist2(index2,5)+(((hist(index2,5)/hist(index2,6))-aveenergy(i,j,k,ii,jj))**2)
		  hist2(index2,6)=hist2(index2,6)+1.0
 

		  enddo
		 enddo
		enddo
	   enddo
	  enddo

	 
	   do i=1,2000

		if(hist(i,3).ne.0) then
	
		  hist2(i,1)=(((hist2(i,1)/hist2(i,3)))**0.5)
		  hist2(i,2)=(((hist2(i,2)/hist2(i,3)))**0.5)
	    endif
		  
		if(hist(i,6).ne.0) then
		  hist2(i,4)=(((hist2(i,4)/hist2(i,6)))**0.5)
		  hist2(i,5)=(((hist2(i,5)/hist2(i,6)))**0.5)
	    endif
	   
	   
	   enddo

  602   format(A,I1,A)


	  do i=1,2000

	    if(hist(i,3).ne.0) then
	    write (36,*) hist(i,1)/hist(i,3), hist(i,2)/hist(i,3), hist(i,3),
     &  hist2(i,1), hist2(i,2), hist2(i,3), log(hist(i,1)/hist(i,3)), 
     &  log(hist(i,2)/hist(i,3))
	 
	 endif
		
		if(hist(i,6).ne.0) then
		write (37,*) hist(i,5)/hist(i,6), hist(i,4)/hist(i,6), hist(i,6),
     &  hist2(i,4), hist2(i,5), hist2(i,6), log(hist(i,5)/hist(i,6)), 
     &  log(hist(i,4)/hist(i,6))	 
		endif

       
c	    write(6,*)hist(i,1)/hist(i,3), hist(i,2)/hist(i,3)


  300  continue
	   enddo

	  close(36)
	  close(37)
		
		

      end
